{$IfDef VER80}
{$X+}
{$Else}
{$X+,H-}
{$EndIf}
unit jbDbf;
{1999 (c) Jaro Benes}
{prace s tabulkou DBF, komponent je castecne odladeny}
{pro verze D1..D4}
interface

uses SysUtils, Classes, Dialogs;

{hlasky lze bud doplnit diakritikou nebo vrazit do RES}
Const
  msgCreateDBFError = 'Nemohu vytvorit novou DBF tabulku';
  msgErrorOnOpen = 'Nemohu otevrit DBF tabulku';
  msgEOFmarkMiss = 'Chybi oznaceni konce souboru';
  msgNoPasswordMatch = 'Nesouhlasi overovaci heslo administratora';
  msgNotEnoughtCreateIdx = 'Nemohu vytvorit IDX soubor';
  msgIdxTableNotFound = 'Nemohu otevrit IDX soubor "%s"';
  msgErrorOnIdxTable = 'Nesouhlasi mohutnost IDX souboru "%s"';
  msgIdxFieldNotFound = 'Nebyla nalezena polozka "%s"';
  msgFileIsTooLarge = 'Soubor ma priliz mnoho polozek nez muze tato verze zpracovat';
  msgErrorOnWrite = 'Chyba pri pokusu o zapis do tabulky';
  msgFileTooRemote = 'Soubor je priliz vzdaleny az nedostupny';
  msgCannotOpenTable = 'Tabulka se nenechala otevrit';
  msgCannotDeleteItem = 'Zaznam z tabulky nejde odstranit';
  msgCannotAddItem = 'Novy zaznam nejde do tabulky pridat';
  msgBadDefinitionOfField = 'Chybna definice zaznamu pole tabulky';
  msgDuplicateInUnique = 'Pokus pridat do unikatniho klice duplicitu';
  msgErrorOnMemoOpen = 'Chyba pri otevirani memo souboru';
  prgMakeIndexSort = 'Vytvarim indexovou strukturu';
  prgWriteIndexSort = 'Zapisuji index na disk';
  prgSearchByKey = 'Prohledavam tabulku dle indexu';

{----------------------------------------------------------------------------}
Const
  MaxSize = $7FFF; { Velikos bufferu zaznamu }
  MaxItems = 16384;
  MaxFields = 128;  { nejvetsi pocet sloupcu }
  DeleteFlag = '*';
  EOFFlag = #$1A;
Type
  charay11=Array [0..10] Of Char;

  {zapis pe podaril, db je nedostupna-v transakci, storno operace, chyba pri zapisu}
  TStatusWrite = (dbfOK, dbfBussy, dbfCancel, dbfError);
  {zaznam je ukladan jako novy, nebo je obcerstvovan}
  TPostAct = (dbfNew, dbfUpdate);
  {pole ma unikatni klic, duplicitni klic,autoinkcementalni klic}
  TFieldReq = (dbfUnique, dbfDuplicates);
  {pole razeno vzestupne, sestupne, podle alternativniho klice}
  TSortByIndex = (dbfAscending, dbfDescending, dbfAlternative);

  TDBFError = procedure (Sender: TObject; Const ErrorMsg: String) of object;
  TDBFMakeItems = procedure (Sender: TObject; Posit: Integer;
   Var INname: ChAray11; Var IWhat: Char; Var ILen, IPlaces: Byte;
   Var IDXName:charay11;Var Req: TFieldReq; Var Sort: TSortByIndex) of object;
  TDBFProgress = procedure (Sender: TObject; Const Operace: OpenString; Progress: Integer) of object;
  TDBFPassword = procedure (Sender: TObject; Var Pass: OpenString) of object;
  TDBFAssigned = procedure (Sender: TObject; Var FName: OpenString) of object;
  TDBFBeforeConfirm = procedure (Sender: TObject; Const FName:String; Var Confirm: Boolean) of object;
  TDBFConfirm = procedure (Sender: TObject; Var Confirm: Boolean) of object;
  TDBFNavigate = procedure (Sender: TObject; Position: LongInt) of object;
  TDBFOpened = procedure (Sender: TObject; IsOpened: Boolean) of object;
  TDBFChange = procedure (Sender: TObject; Var Cancel: Boolean) of object;
  TDBFActualize = procedure (Sender: TObject; Status: TPostAct) of object;
  TDBFQuery = procedure (Sender: TObject; Const IdxName, IdxField, Key: OpenString;
    Var Accept, Cancel: Boolean) of object;
  TDBFAltSort = procedure (Sender: TObject; TblIdx: TStringList) of object;

  TRecArray = Array [0..MaxSize] of Char;
  PRecArray = ^TRecArray;
  PBigArray = PRecArray;

  TDBFHeader = record         { popisky jsou z manualu, upraveny pro me potreby}
    version        : byte;    { Should be 3 or $83                           1 }
                              { $3  - FoxBase+/dBase III Plus bez souboru MEMO }
                              {     - FoxPro/dBase IV bez souboru memo
                              { $83 - FoxBase+/dBase III Plus se souborem MEMO }
                              { $F5 - FoxPRo se souborem memo                  }
                              { $8B - dBase IV se souborem memo                }
    year,month,day : byte;    { Date of last update                          3 }
    numRecs        : longint; { Number of records in the file                4 }
    headLen        : word;    { Length of the header                         2 }
    recLen         : word;    { Length of individual records                 2 }
    nets           : word;    { not used                                       }
    transaction    : byte;    { begin-end transaction                          }
                              { 00 - no transaction protected                  }
                              { 01 - transaction protected                     }
    encrypted      : byte;    { coded fields                                   }
                              { 00 - uncrypted                                 }
                              { 01 - encrypted                                 }
    network        : array [1..12] of byte;
    mdxfile        : byte;    { exist .mdx file indicator                      }
                              { 00 - non exist                                 }
                              { 01 - exist and join                            }
    LangDrv        : byte;    { language driver /fox/                          }
                              { 001 - kodova stranka 437                       }
                              { 002 - kodova stranka 850                       }
                              { 100 - kodova stranka 852                       }
                              { 102 - kodova stranka 865                       }
                              { 101 - kodova stranka 866                       }
                              { 104 - kodova stranka 895                       }
                              { 200 - kodova stranka 1250                      }
                              { 201 - kodova stranka 1251                      }
                              { 003 - kodova stranka 1252                      }
    labeled        : word;
  end;

Const
  TdbTypes:Set of Char = ['C'{characters, all ascii},
                          'D'{date ddmmyyyy, fix size 8},
                          'T'{time hhmmss, fix size 6},
                          'F'{float point, -,.,0..9},
                          'L'{logical, ?,Y,y,N,n},
                          'M'{memo, as numeric, fix size 10},
                          'N'{numeric, -,.,0..9}];
  {struktura zazn. zapisniku, pripojene soubory predava pres disk}
Type
  TDBTTypes=Record
    NumberOf:LongInt;                 { cislo zaznamu}
    AsFileType:Array [1..3] of Char;  { extenze ulozeneho typu}
    Used:Boolean;                     { pouzito}
    SizeOfMemo:LongInt;               { velikost pripojeneho souboru}
    FileDateTime:Double;              { originalni datum a cas souboru}
    {MemoField:Array[1..SizeOfMemo] of Byte; // ulozeny soubor}
  End;
  {
  struktura zaznamu klice, je bez hlavicky
  TIDXTypes=Record
    ItemNo:LongInt;                   // odkaz na zaznam v tabulce
    Key:TDBField.Len;                 // klicova polozka
  End;
  }

Type
  TdbField = Record
    name   : charay11;           { Name of the field                     11 }
    what   : Char;               { Type of data in this field             1 }
    data   : array[0..1] of word;{ Not used                               2 }
    len    : byte;               { Length of the field                    1 }
    places : byte;               { Number of decimal places               1 }
    idxtyp : TFieldReq;          { typ klice unikatni/duplicitni...       1 }
    idxsrt : TSortByIndex;       { setridit vzestupne, sestupne, custom...1 }
    dfIdent: Byte;               { datafield identifier ??                1 }
    idx    : charay11;           { sem jmeno souboru indexu XXXXXXXXIDX  11 }
  End;

Type
  TKey=String;
{----------------------------------------------------------------------------}
  TDBF = class(TComponent)
  private
    FDBFName        : String;     { Uplne jmeno tabulky }
    FDBFIsOpened    : Boolean;    { TRUE kdyz je soubor otevren }
    FDBFStoreByIndex: Boolean;    { Uklada podle seznamu indexu }
    FDBFHandle      : File;       { Tohle je handle aktualniho souboru }
    FDBFExist       : Boolean;    { Indikuje, zda soubor existuje pri prideleni jmena }
    FDBFReadOnly    : Boolean;    { Pouze ke cteni }
    FDBFSaveOnClose : Boolean;    { Ulozit pri uzavreni }
    FDBFHeader      : TDBFHeader; { Hlavicka, naplni se po otevreni}
    FDBFIndex       : String;     { Aktualni index pro Find}
    FDBFPassword    : String;     { heslo administratora }
    FDBFFilter      : String;     { neni vyuzit}
    FDBFIndexList   : TStringList;{ Seznam vsech indexu k tabulce}
    FDBFBuff        : PBigArray;  { Temp FDBFBuff for record }
    FDBFCurrRec     : LongInt;    { Kurzor je postaven na teto vete }
    FDBFCountItems  : Integer;    { Pocet sloupcu ve vete }
    FDBFCurrRecDel  : Boolean;    { Znacka zaznamu v bufferu pro vymazani }
    FOnError        : TDBFError;        {event pro chyby}
    FOnWarn         : TDBFError;        {event pro varovani}
    FOnMakeFields   : TDBFMakeItems;    {pro vytvareni polozek ve vete}
    FOnErase        : TDBFBeforeConfirm;{pro souhlas se zrusenim souboru .DBF}
    FOnOverwrite    : TDBFBeforeConfirm;{pro souhlas s prepsanim souboru .DBF .IDX}
    FOnAdded        : TNotifyEvent;     {je-li veta pridana}
    FDBFOnAltSort   : TDBFAltSort;      {alternativni setrideni na stringlistu}
    FOnChange       : TDBFChange;       {je-li veta menena}
    FOnChanged      : TNotifyEvent;     {je-li veta zmenena}
    FOnDelete       : TDBFConfirm;
    FOnActualize    : TDBFActualize;
    FOnDeleted      : TNotifyEvent;     {je-li veta vymazana}
    FOnPassword     : TDBFPassword;     {je-li pozadovano overeni administratorem}
    FOnOpened       : TDBFOpened;       {je-li soubor otevren}
    FOnAsSigned     : TDBFAsSigned;     {je-li soubor attachnut}
    FOnFound        : TNotifyEvent;     {je-li nalezena veta dle indexu}
    FOnErased       : TNotifyEvent;     {je-li tabulka uz vymazana}
    FOnNavigate     : TDBFNavigate;     {je-li volana navigace}
    FOnProgress     : TDBFProgress;     {je-li volan update .DBF ukazuje procenta}
    FOnUpdate       : TNotifyEvent;     {je-li veta aktualizovana}
    FOnClosed       : TNotifyEvent;     {je-li tabulka uzavrena}
    FOnLoaded       : TNotifyEvent;     {je-li zaznam natazen do pameti bufferu}
    FOnQuery        : TDBFQuery;        {pro dotaz pomoci find}

    procedure SetFileName(name : string);
    Function GetPassword: String;
    procedure SetPassword(Const thepassword:String);
  protected
    FDBFFields    : array[1..maxFields] of TdbField;  { The field data }
    procedure Fatal(Const Msg:String);
    Procedure Warn(Const Msg:String);
    Procedure Actualization;
  public
    constructor Create(AOWner : TComponent); override;
    destructor Destroy; override;

    procedure Close; virtual;
    Function  Open:Boolean; virtual;
    Function  Write(r : longint):TStatusWrite; virtual;
    procedure Seek(r : longint); virtual;
    procedure NewRecord; virtual;
    procedure GotoStart;
    procedure GotoEnd;
    procedure GotoNext;
    Procedure GotoPrev;
    Function  Delete(R : longint):TStatusWrite; Virtual;
    Function  UpdateIndexes(R:LongInt):Boolean; Virtual;
    Procedure RemoveIndexes(R:LongInt); Virtual;
    procedure MakeIndex(Const IdxName:String; Const Key:TKey);{vytvori index} Virtual;
    Procedure Find(Const IdxName, Value:String);{hleda hodnotu podle klice} Virtual;
    Procedure Store(Const Key:TKey; Const Rec:String);{polozky vety} Virtual;
    Procedure ELoad(Const Key:TKey; Var Rec:String);{i s konverzi} Virtual;
    Function  Load(Const Key:TKey):String;
    Procedure Update(R:LongInt); Virtual;
    procedure CreateDB(Const fname:String;rL{reclen},numFields: word); Virtual;
    Function  MakeField(posit:Byte;Const iname:String;iwhat:Char;ilen:byte;
                        iplaces:byte;Const idxnme:String;
                        Req:TFieldReq;Sort:TSortByIndex):Boolean; Virtual;
    Function  Cover:Boolean; Virtual;
    Procedure UnCover; Virtual;
    Procedure RemoveIndex(Const Name: String); Virtual;
    Function  IsMarked:Boolean;{je v transakci?} Virtual;
    Function  ReIndex:Boolean; Virtual;
    Procedure IncNumRec;
    Function  SaveMemo(No:LongInt;Const FName:String):Boolean; Virtual;
    Function  LoadMemo(No:LongInt;Var FName:String):Boolean; Virtual;
    Function  EraseMemo(No:LongInt):Boolean; Virtual;
    Procedure PruneDBF; Virtual;
    Procedure PruneDBT; Virtual;
    property  CurrRec: LongInt read FDBFCurrRec;
  published
    property CurrentRecDeleted : Boolean read FDBFCurrRecDel;
    property FileIsOpen : Boolean read FDBFIsOpened;
    property StoreByIndex : Boolean read FDBFStoreByIndex write FDBFStoreByIndex;
    property FileIsExist : Boolean read FDBFExist;
    property ReadOnly : Boolean read FDBFReadOnly write FDBFReadOnly;
    property SaveOnClose : Boolean read FDBFSaveOnClose write FDBFSaveOnClose;
    property ByIndex : String read FDBFIndex write FDBFIndex;
    property Password : String read GetPassword write SetPassword;

    property FileName     : string read FDBFName write SetFileName;
    property OnError      : TdbfError read FOnError write FOnError;
    property OnWarn       : TdbfError read FOnWarn write FOnWarn;
    property OnMakeFields : TDBFMakeItems read FOnMakeFields write FOnMakeFields;
    property OnErase      : TDBFBeforeConfirm read FOnErase write FOnErase;
    property OnOverwrite  : TDBFBeforeConfirm read FOnOverwrite write FOnOverwrite;
    property OnAdded      : TNotifyEvent read FOnAdded write FOnAdded;
    property OnAltSort    : TDBFAltSort read FDBFOnAltSort write FDBFOnAltSort;
    property OnChange     : TDBFChange read FOnChange write FOnChange;
    property OnChanged    : TNotifyEvent read FOnChanged write FOnChanged;
    property OnDelete     : TDBFConfirm read FOnDelete  write FOnDelete;
    property OnDeleted    : TNotifyEvent read FOnDeleted write FOnDeleted;
    property OnPassword   : TDBFPassword read FOnPassword write FOnPassword;
    property OnOpened     : TDBFOpened read FOnOpened write FOnOpened;
    property OnAsSigned   : TDBFAsSigned read FOnAsSigned write FOnAsSigned;
    property OnFound      : TNotifyEvent read FOnFound write FOnFound;
    property OnErased     : TNotifyEvent read FOnErased write FOnErased;
    property OnNavigate   : TDBFNavigate read FOnNavigate write FOnNavigate;
    property OnProgress   : TDBFProgress read FOnProgress write FOnProgress;
    property OnUpdate     : TNotifyEvent read FOnUpdate write FOnUpdate;
    property OnClosed     : TNotifyEvent read FOnClosed write FOnClosed;
    property OnLoaded     : TNotifyEvent read FOnLoaded write FOnLoaded;
    property OnActualize  : TDBFActualize read FOnActualize write FOnActualize;
    property OnQuery      : TDBFQuery read FOnQuery write FOnQuery;
  end;

procedure Register;

implementation

{----------------------------------------------------------------------------}
procedure Register;
{----------------------------------------------------------------------------}
begin
  RegisterComponents('Lib', [TDBF]);
end;

{$IFDEF VER80}
{----------------------------------------------------------------------------}
Function Trim(Const S:String):String;
{----------------------------------------------------------------------------}
Begin
  Result:=S;
  While (Length(Result)>0) And (Result[1] <= ' ') Do
    System.Delete(Result,1,1);
  While (Length(Result)>0) And (Result[Length(Result)] <= ' ') Do
    System.Delete(Result,Length(Result),1);
End;
{$ENDIF}

{----------------------------------------------------------------------------}
Constructor TDBF.Create(AOwner : TComponent);
{----------------------------------------------------------------------------}
Begin
  Inherited Create(AOwner);
  FDBFIsOpened := False;
  FileName := '';
  FDBFBuff := Nil;
  FDBFIndexList := TStringList.Create;
  FDBFStoreByIndex := False;
  FDBFExist := False;
  FDBFReadOnly := False;
  FDBFSaveOnClose := False;
End;

{----------------------------------------------------------------------------}
Destructor TDBF.Destroy;
{----------------------------------------------------------------------------}
Begin
  {kdyby byla nahodou tabulka otevrena, tak ji explicitne uzavri}
  If FDBFIsOpened Then
    close;
  {ivolni instanci seznamu}
  FDBFIndexList.Free;
  Inherited destroy;
End;

{----------------------------------------------------------------------------}
procedure TDBF.SetFileName(name : string);
{----------------------------------------------------------------------------}
Begin
  {kdyby byla nahodou tabulka otevrena, tak ji explicitne uzavri}
  If FDBFIsOpened Then
    Close;
  {a pak zmen jmeno}
  FDBFName:=name;
  {prirazeni jmena oznam, a nabidni k pripadne zmene zvenku}
  If AsSigned(FOnAsSigned) Then FOnAsSigned(Self, FDBFName);
  FDBFName:=LowerCase(FDBFName);
  {test, zda tabulka existuje, neexistuje-li, bude potreba ji zalozit}
  FDBFExist:=FileExists(FDBFName);
End;

{----------------------------------------------------------------------------}
Function TDBF.GetPassword: String;
{----------------------------------------------------------------------------}
Begin
  Result := LowerCase(FDBFPassword)
End;

{----------------------------------------------------------------------------}
procedure TDBF.SetPassword(Const thepassword:String);
{----------------------------------------------------------------------------}
Begin
  FDBFPassword := thepassword
End;

{----------------------------------------------------------------------------}
Function TDBF.Open:Boolean;
{----------------------------------------------------------------------------}
var
  Temp : TdbField;
  Done : Boolean;
  Readed:{$IfDef VER80}Word{$Else}Integer{$EndIf};
  Pass : String;
begin
  Result := False;
  {kdyby nahodou byla tabulka otevrena, tak ji zavri}
  If FDBFIsOpened Then Close;
  {neexistuje-li tabulka, nedelej nic}
  If Not FDBFExist Then Exit;

  done:=FALSE;

  If AsSigned(FOnPassword) Then FOnPassword(Self,Pass);
  {prikryti heslem je mozne overit tady}
  If FDBFPassword<>'' Then
    If Pass<>FDBFPassword Then Begin
      Fatal(msgNoPasswordMatch);
      Exit;
    End;
  {otevreni pres handle}
  AsSignFile(FDBFHandle,FDBFName);
  Try
    Reset(FDBFHandle,1);
    {kdyz se povedlo, zustane otevrena az do close}
    FDBFIsOpened:=True;
    {vyzvedni si header}
    BlockRead(FDBFHandle,FDBFHeader,sizeof(TDBFHeader)); { Get the header }
    {tohle bude pracovni buffer, kam budes davat data}
    GetMem(FDBFBuff,FDBFHeader.RecLen);
    {tady ctes polozky/sloupce a v tehle promenn vzdy budou}
    FDBFCountItems:=0;
    Repeat
      {cti obezretne, co kdybys narazil na neocekacany konec}
      {$I-}
      BlockRead(FDBFHandle,temp,SizeOf(TdbField),Readed);
      {$I+}
      If Temp.name[0]<>#$0D then
        Begin
          {ukazuj na prvni volny}
          inc(FDBFCountItems);
          FDBFFields[FDBFCountItems]:=temp;
          fillchar(temp,SizeOf(temp),0);
        End
      Else
        Begin
          done:=TRUE;
          {jsou-li nacteny prave dva znaky, tabulka je prazdna, uprav pozici}
          If readed=2 Then
            System.Seek(FDBFHandle,System.FilePos(FDBFHandle)-1)
          {jinak se postav na prvni zaznam a nacti ho do bufferu}
          Else seek(0);
        End;
    Until DONE;
    {seek(0);}
    If AsSigned(FOnOpened) Then FOnOpened(Self,FDBFIsOpened);
    Result := True;
  Except
    Fatal(msgErrorOnOpen)
  End;
End;

{----------------------------------------------------------------------------}
procedure TDBF.Close;
{----------------------------------------------------------------------------}
Var B:Byte;
Begin
  {nasleduje test EOF mark a oznaceni kdyz chybi}
  {tohle ale lze udelat v pripade, kdyz soubor neni read only}
  {je-li read only, zahlasi se chyba a nejde soubor opravit}

  System.Seek(FDBFHandle,FileSize(FDBFHandle)-1);
  Blockread(FDBFHandle,b,1);
  If B<>$1A Then Begin
    If Not FDBFReadOnly And Not IsMarked Then
      Begin
        {je-li povoleno stouchni tam posledni zaznam}
        If FDBFSaveOnClose Then Write(CurrRec);
        B:=$1A;
        BlockWrite(FDBFHandle,B,1);
      End
    Else
      Fatal(msgEOFmarkMiss)
  End;
  CloseFile(FDBFHandle);
  {datum aktualizace}
  Actualization;
  FDBFIsOpened:=False; {ohlas ze soubor je uzavren}
  If AsSigned(FOnClosed) Then FOnClosed(Self);
  FreeMem(FDBFBuff,FDBFHeader.RecLen);{uvolni alokovany buffer}
end;

{----------------------------------------------------------------------------}
Function TDBF.Write(R : LongInt):TStatusWrite;
{hlavni funkce zapisu, data jsou vzdy ukladana na pozadani}
{----------------------------------------------------------------------------}
Var Cancel:Boolean;
Begin
  Result := dbfError;
  {zapis muze byt proveden pouze v pripade ze neni jen pro cteni, existuje a je otevren}
  If FDBFReadOnly Or Not FDBFExist Or Not FDBFIsOpened Then Exit;
  {nastav pro pripad, kdyby to pouzival jiny proces}
  Result := dbfBussy;
  {je nastaveno navesti transakce, tj. pouziva to nekdo jiny}
  If Not IsMarked Then Begin
    {ale ted ho chces pouzit ty}
    Cover;
    Try
      {priznak storna}
      Result := dbfCancel;
      Cancel := False;
      If FDBFCurrRec <> R Then FDBFCurrRec := R;
      {kdykoliv zapisujes, pak menis zaznam; zde ho lze odvolat}
      If AsSigned(FOnChange) Then FOnChange(Self, Cancel);
      {je-li zaznam odvolan, zapis nebude proveden}
      If Cancel Then Exit;
      {priznak chyby}
      Result := dbfError;
      {pokousis se updatovat indexy}
      Try
        {jsou-li updatovany}
        If UpdateIndexes(R) Then Begin
          Try
            {vyhledej fyzicky zaznam k prepisu}
            System.Seek(FDBFHandle,R * FDBFHeader.recLen + FDBFHeader.headLen);
            {nastav signal pro platny zapis - zaznam je platny}
            {FDBFBuff^[0]:=' '; { Record not deleted! }
            {zapis ho na vyhledane misto}
            BlockWrite(FDBFHandle,FDBFBuff^,FDBFHeader.RecLen);

            Actualization;
            {teprve tady je vsechno OK}
            Result := dbfOK;
          Except
            On EInOutError Do Begin
              Fatal(msgErrorOnWrite);
              Result := dbfError;
            End;
          End;
          {zahlas, zes zaznam zmenil}
          If AsSigned(FOnChanged) Then FOnChanged(Self);
        End;
      Except
        {v pripade vyskytu nejake chyby je ale musis odstranit}
        RemoveIndexes(R)
      End
    Finally
      {a tady ho zase mohou pouzivat jini}
      UnCover;
    End;
  End;
End;

{----------------------------------------------------------------------------}
Function TDBF.Delete(R : longint):TStatusWrite;
{----------------------------------------------------------------------------}
Var Confirm : Boolean;
Begin
  Result:=dbfError;
  {zapis muze byt proveden pouze v pripade ze neni jen pro cteni, existuje a je otevren}
  If FDBFReadOnly Or Not FDBFExist Or Not FDBFIsOpened Then Exit;
  Result:=dbfBussy;
  If Not IsMarked Then Begin
    Cover;
    Try
      {zadej o svoleni s vymazanim vety}
      If AsSigned(FOnDelete) Then FOnDelete(Self, Confirm) Else Confirm := True;
      If Confirm Then
      Begin
        Try
          {nezmenil-li se zaznam od aktualniho}
          If FDBFCurrRec <> R Then FDBFCurrRec := R;
          {vyhledej ho v zaznamech}
          System.Seek(FDBFHandle,R * FDBFHeader.recLen + FDBFHeader.headLen);
          {nastav priznak vymazani}
          FDBFBuff^[0]:=DeleteFlag; { Record is deleted! }
          {zapis do souboru}
          BlockWrite(FDBFHandle,FDBFBuff^,FDBFHeader.recLen);
          {aktualizuj indexy, tj. odstran z nich vymazany zaznam}
          RemoveIndexes(R);

          Actualization;
        Except
          On EInOutError Do Fatal(msgCannotDeleteItem);
        End;
        {oznam zes vymazal}
        If AsSigned(FOnDeleted) Then FOnDeleted(Self);
      End;
    Finally
      UnCover;
    End
  End;
End;

{----------------------------------------------------------------------------}
procedure TDBF.Seek(R : LongInt);
{----------------------------------------------------------------------------}
var
  L      : LongInt;
  Readed : {$IfDef VER80}Word{$Else}Integer{$EndIf};
begin
  If Not FDBFExist Or Not FDBFIsOpened Then Exit;
  {nezmenil-li se zaznam od aktualniho}
  If FDBFCurrRec <> R Then FDBFCurrRec := R;
  {fyzicka delka zacatku vet}
  L := R * FDBFHeader.recLen + FDBFHeader.headLen;
  If L > (FileSize(FDBFHandle)-1) Then Exit;{kdyz je nahodou za}
  {postav se tam}
  System.Seek(FDBFHandle, L);
  {precti vetu do bufferu}
  BlockRead(FDBFHandle, FDBFBuff^, FDBFHeader.RecLen, Readed);
  {veta je uspesne nactena, jen kdyz je v bufferu cela}
  If FDBFHeader.RecLen = Readed Then
    {a zahlas zes ji precetl}
    If AsSigned(FOnLoaded) Then FOnLoaded(Self);
end;

{----------------------------------------------------------------------------}
procedure TDBF.GotoStart;
{----------------------------------------------------------------------------}
begin
  If Not FDBFExist Or Not FDBFIsOpened Then Exit;
  {nastav se na prvni zaznam}
  Seek(0);
  {zahlas pro navigaci, ze na nem stojis}
  If AsSigned(FOnNavigate) Then FOnNavigate(Self, 0);
end;

{----------------------------------------------------------------------------}
procedure TDBF.GotoEnd;
{----------------------------------------------------------------------------}
begin
  If Not FDBFExist Or Not FDBFIsOpened Then Exit;
  {nastav se na posledni zaznam}
  Seek(FDBFHeader.numRecs-1);
  {zahlas pro navigaci, ze na nem stojis}
  If AsSigned(FOnNavigate) Then FOnNavigate(Self, FDBFHeader.numRecs-1);
end;

{----------------------------------------------------------------------------}
procedure TDBF.GotoNext;
{----------------------------------------------------------------------------}
begin
  If Not FDBFExist Or Not FDBFIsOpened Then Exit;
  {nastav se na nasledujici zaznam}
  Seek(FDBFCurrRec+1);
  {zahlas pro navigaci, ze na nem stojis}
  If AsSigned(FOnNavigate) Then FOnNavigate(Self, FDBFCurrRec+1);
end;

{----------------------------------------------------------------------------}
Procedure TDBF.GotoPrev;
{----------------------------------------------------------------------------}
begin
  If Not FDBFExist Or Not FDBFIsOpened Then Exit;
  {nastav se na predchazejici zaznam}
  Seek(FDBFCurrRec-1);
  {zahlas pro navigaci, ze na nem stojis}
  If AsSigned(FOnNavigate) Then FOnNavigate(Self, FDBFCurrRec-1);
end;

{----------------------------------------------------------------------------}
procedure TDBF.NewRecord;
{----------------------------------------------------------------------------}
begin
  {nemuzes nic pridavat, kdyz je jen ke cteni, nebo neexistuje, neni otevren}
  If FDBFReadonly Or Not FDBFExist Or Not FDBFIsOpened Then Exit;
  If Not IsMarked Then Begin
    Cover;
    Try
      {vycisti buffer}
      {FillChar(FDBFBuff^,FDBFHeader.RecLen,' ');}
      {zde je mozne udelat implicitni naplneni zaznamu, coz vrele doporucuji}
      If AsSigned(FOnActualize) Then FOnActualize(Self,dbfNew);
      Try
        {zvyz pocet zaznamu a uloz je do hlavicky}
        IncNumRec;
        {jdi na fyzicky zacatek}
        System.Seek(FDBFHandle,0);
        {zapis hlavicku}
        BlockWrite(FDBFHandle,FDBFHeader,SizeOf(TDBFHeader));
        {zapis-vloz novy zaznam na konec}
        Write(FDBFHeader.numRecs-1);
        {nastav se na ten zaznam a aktualizuj buffer}
        Seek(FDBFHeader.numRecs-1);
      Except
        On EInOutError Do Fatal(msgCannotAddItem);
      End;
      {a pripadne zahlas, ze zaznam byl pridan}
      If AsSigned(FOnAdded) Then FOnAdded(Self);
    Finally
      UnCover;
    End;
  End;
end;

{----------------------------------------------------------------------------}
procedure TDBF.CreateDB(Const fname:String;rL{reclen},numFields: word);
{----------------------------------------------------------------------------}
Var
  y,m,d : Word;
  c:Char;
  i,j:Byte;
Begin
  {kdyby byla nahodou tabulka otevrena, tak ji explicitne uzavri}
  If FDBFIsOpened Then
    Close;

  {vytvatis novou tabulku, zde je hlavicka}
  FillChar(FDBFHeader,SizeOf(FDBFHeader),0);
  With FDBFHeader Do Begin
    version:=$3;
    DecodeDate(Date,y,m,d); {datum vytvoreni}
    year:=y Mod 100;
    month:=Lo(m);
    day:=Lo(d);
    numRecs:=0;
    headLen:=SizeOf(FDBFHeader)+SizeOf(TDBFHeader) * numFields + 1;
    recLen:=rl + 1; {begins delete flag}
  End;
  {tohle je nove jmeno tabulky}
  FDBFName:=fname;
  {priprav ji k fyzickemu zalozeni}
  AsSignFile(FDBFHandle,FDBFName);
  Try
    ReWrite(FDBFHandle,1);
    Try
      {zalozeni se povedlo, tabulka je otevrena}
      FDBFIsOpened:=TRUE;
      {zapis hlavicku}
      BlockWrite(FDBFHandle,FDBFHeader,sizeof(TDBFHeader));
      {pro stanoveny pocet sloupcu prochazej}
      For i:=1 To numFields Do Begin
        {jestlize je attachnuty event pro vyrobu pole on line tak ho zavolej}
        {jinak je predpokladano ze pred volanim teto metody byly
         vytvoreny sloupce pomoci MakeField()}
        If AsSigned(FOnMakeFields) Then Begin
          {zavolej ho tolikrat, kolik je potreba vyrobit poli}
          FillChar(FDBFFields[i],SizeOf(FDBFFields[i]),0);
          {zavolej ho a vyrob zaznam}
          With FDBFFields[I] Do
            FOnMakeFields(Self,I,Name,What,Len,Places,idx,idxtyp,idxsrt);
          {uprav na velka pismena}
          For j:=0 to 10 Do FDBFFields[i].Name[j]:=UpCase(FDBFFields[i].Name[j]);
          FDBFFields[i].What := UpCase(FDBFFields[i].What);
        End;
        {zapis nove vyrobene pole}
        BlockWrite(FDBFHandle,FDBFFields[i],sizeof(TdbField))
      End;
      {za hlavickou nasleduje vzdy CR}
      c:=#$0D;
      BlockWrite(FDBFHandle,c,1);
      {konec souboru je indikovan EOF mark}
      c:=#26;
      BlockWrite(FDBFHandle,c,1);
    Finally
      {tady soubor fyzicky zavri}
      CloseFile(FDBFHandle);
    End;
  Except
    {ejhle, chyba; tak ji zahlas}
    Fatal(msgCreateDBFError)
  End;
  {tabulka je stale uzavrena}
  FDBFIsOpened:=False;
End;

{----------------------------------------------------------------------------}
Function  TDBF.MakeField( posit:Byte;
                          Const iname:String;
                          iwhat:Char;
                          ilen:byte;
                          iplaces:byte;
                          Const idxnme:String;{jmeno souboru na xxxxxxxxIDX}
                          Req:TFieldReq;
                          Sort:TSortByIndex
                        ):Boolean;
{----------------------------------------------------------------------------}
Var
  I:byte;
  S:String;
  X:String[8];
Begin
  Result := False;
  If (Trim(IName)='') Or Not(UpCase(IWhat) in TdbTypes) Or (ILen = 0) Then Begin
    Fatal(msgBadDefinitionOfField);
    Exit;
  End;
  Result := True;
  FillChar(FDBFFields[posit],SizeOf(FDBFFields[posit]),0);
  With FDBFFields[posit] Do Begin
    {prvnich 11 znaku, velka pismena}
    S:=Copy(UpperCase(Trim(IName)),1,11);
    Move(S[1],Name,Length(S));
    What   := UpCase(IWhat);
    {tyhle polozky (cas, datum, memo) maji fixni tvar}
    Case What of
      'T': Len := 6;
      'D': Len := 8;
      'M': Len := 10;
      'F': Places := IPlaces; {tohle je jenom pro float}
    Else
      Len    := ILen;
    End;

    If (IdxNme<>'') Then Begin
      I:=Pos('.',IdxNme);
      If I>0 Then Begin
        S:=Trim(Copy(IdxNme,I+1,3));
        If Length(S)<3 Then While Length(S)<3 Do S:=S+' ';
        X:= Trim(Copy(IdxNme,1,I-1));
        If Length(X)<8 Then While Length(X)<8 Do X:=' '+X;
        S:=X+S;
      End
      Else Begin
        X:=Trim(IdxNme);
        If Length(X)<8 Then While Length(X)<8 Do X:=' '+X;
        S:=X+'IDX';
      End;
      S:=UpperCase(S);
      Move(S[1],idx,11);
    End;
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.Fatal(Const Msg:String);
{----------------------------------------------------------------------------}
Begin
  {kdyz je vnejsi zpracovani msg, tak ho zavolej, jinak ukaz vlastni}
  If AsSigned(FOnError) Then FOnError(Self,msg)
  Else
    MessageDlg(msg, mtError, [mbOk], 0);
End;

{----------------------------------------------------------------------------}
Procedure TDBF.Warn(Const Msg:String);
{----------------------------------------------------------------------------}
Begin
  {s varovanim je to stejne tak}
  If AsSigned(FOnWarn) Then FOnWarn(Self,msg)
  Else
    MessageDlg(msg, mtWarning, [mbOk], 0);
End;

{----------------------------------------------------------------------------}
Function  TDBF.UpdateIndexes(R:LongInt):Boolean;
{----------------------------------------------------------------------------}
Var
  I,J,L:LongInt;
  TempFName:String;
  F:File;
  T:TStringList;
  S,X:String;
  UpdateField:Boolean;
Begin
  {indikace uspesneho  ukonceni}
  Result := True;
  {indexy se aktualizuji zde, ale jen kdyz to chces}
  If Not FDBFStoreByIndex Then Exit;
  {doslo-li k uspesnemu updatu, funkce vrati True jinak udela removeindexes}
  For I:=1 To FDBFCountItems Do Begin
    {prochazis vsechny sloupce a hledas indexovy soubor}
    If Trim(FDBFFields[I].Idx)<>'' Then Begin
      {indexovy soubor byl nalezen}
      {jeho jmeno je ve tvaru xxxxxxxxIDX, vzdy zarovnan vpravo}
      {vyplne jsou ' ' tj. "~~~JMENOIDX" nebo "~~ZAMESTID~"}
      {vyrob temp jmeno souboru}
      TempFName:=ExtractFilePath(FDBFName)
       +Trim(Copy(FDBFFields[I].Idx,1,8)+'.'+Copy(FDBFFields[I].Idx,9,3));
      If FileExists(TempFName) Then Begin
        AsSignFile(F,TempFName);
        Try
          ReSet(F,1);
          Try
            UpdateField:=False;
            {proc nepouzit k indexum stringlist?}
            T:=TStringList.Create;
            Try
              {budes tridit radky}
              T.Sorted:=True;
              {nastavujes vlastnost duplicit}
              Case FDBFFields[I].idxtyp Of
                dbfUnique:T.Duplicates := dupError;
                dbfDuplicates:T.Duplicates := dupAccept;
              End;
              While Not Eof(F) Do Begin
                {uprava indexu je zde}
                BlockRead(F,S[1],FDBFFields[I].len+SizeOf(L));
                Move(S[1],L,SizeOf(L));
                {neni tam nahodou uz nektery k uprave?}
                If R=L Then Begin
                  ELoad(FDBFFields[I].Name,X);
                  Move(X[1],S[5],Length(X));{zkus ho tam pridat}
                  UpdateField:=True;
                End;
                Try
                  T.Add(' '+Copy(S,5,255)+#1+IntToStr(L));
                Except
                  On EListError Do
                    If T.Duplicates = dupError Then Begin
                      Warn(msgDuplicateInUnique);
                      Result:=False;
                      Exit;
                    End;
                End;
              End{while};
              {vlozil jsi vsechny ze souboru, tak ted zkus primy}
              If Not UpdateField Then Begin
                ELoad(FDBFFields[I].Name,X);
                Try
                  T.Add(' '+X+#1+IntToStr(R));
                Except
                  On EListError Do
                    If T.Duplicates = dupError Then Begin
                      Warn(msgDuplicateInUnique);
                      Result:=False;
                      Exit;
                    End;
                End;
              End;
              {byl-li index uspesne vlozen, uloz indexovy soubor}
              ReWrite(F,1);{vymaz puvodni}
              Case FDBFFields[I].idxsrt Of
                dbfAscending:
                Begin
                  For J := 0 To T.Count-1 Do Begin
                    S:=T.Strings[J];
                    L:=StrToInt(Copy(S,Pos(#1,S)+1,255));
                    S:='   '+Copy(S,1,Pos(#1,S)-1);
                    Move(L,S[1],SizeOf(L));
                    BlockWrite(F,S[1],Length(S));
                  End;
                End;
                dbfDescending:
                Begin
                  For J := T.Count - 1 DownTo 0 Do Begin
                    S:=T.Strings[J];
                    L:=StrToInt(Copy(S,Pos(#1,S)+1,255));
                    S:='   '+Copy(S,1,Pos(#1,S)-1);
                    Move(L,S[1],SizeOf(L));
                    BlockWrite(F,S[1],Length(S));
                  End;
                End;
                dbfAlternative:
                Begin
                  {Potrebujete-li to, tak jedine doprogramovat}
                  If AsSigned(FDBFOnAltSort) Then FDBFOnAltSort(Self,T);
                  {a uloz to ...}
                  For J:=0 To T.Count-1 Do Begin
                    S:=T.Strings[J];
                    L:=StrToInt(Copy(S,Pos(#1,S)+1,255));
                    S:='   '+Copy(S,1,Pos(#1,S)-1);
                    Move(L,S[1],SizeOf(L));
                    BlockWrite(F,S[1],Length(S));
                  End;
                End;
              End;
            Finally
              T.Free {zahod ho}
            End;
            {idxsrt:TSortByIndex = (dbfAscending, dbfDescending, dbfAlternative);}
          Finally
            CloseFile(F);
          End;
        Except
          Fatal(Format(msgIdxTableNotFound,[ExtractFileName(TempFName)]));
        End;
      End
      Else Begin
        AsSignFile(F,TempFName);
        {tabulka jeste neexistuje}
        ReWrite(F,1);
        ELoad(FDBFFields[I].Name,X);
        Move(R,S[1],SizeOf(R));
        Move(X[1],S[5],Length(X));{zkus ho tam pridat}
        BlockWrite(F,S[1],Length(X)+SizeOf(R));
        CloseFile(F);
      End;
    End;
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.RemoveIndexes(R:LongInt);
{----------------------------------------------------------------------------}
Var
  I:Integer;
  L:LongInt;
  TempFName,S:String;
  F,Fnew:File;
Begin
  {je-li nejaky zaznam vymazan, musi se tez odstranit ze vsech indexu}
  For I:=1 To FDBFCountItems Do Begin
    {prochazis vsechny sloupce a hledas indexovy soubor}
    If Trim(FDBFFields[I].Idx)<>'' Then Begin
      {indexovy soubor byl nalezen}
      {jeho jmeno je ve tvaru xxxxxxxxIDX, vzdy zarovnan vpravo}
      {vyplne jsou ' ' tj. "~~~JMENOIDX" nebo "~~ZAMESTID~"}
      {vyrob temp jmeno souboru}
      TempFName:=ExtractFilePath(FDBFName)
       +Trim(Copy(FDBFFields[I].Idx,1,8)+'.'+Copy(FDBFFields[I].Idx,9,3));
      AsSignFile(F,TempFName);
      Try
        ReSet(F,1);
        Try
          AsSignFile(Fnew,ChangeFileExt(TempFName,'.$$$'));
          Try
            ReWrite(Fnew,1);
            Try
            While Not Eof(f) Do Begin
              BlockRead(F,S[1],FDBFFields[I].len+SizeOf(L));
              Move(S[1],L,SizeOf(L));
              If L<>R Then Begin
                BlockWrite(Fnew,S[1],FDBFFields[I].len+SizeOf(L))
              End;
            End;
            Finally
              CloseFile(Fnew);
            End;
          Except
            Warn(msgNotEnoughtCreateIdx)
          End;
        Finally
          CloseFile(F);
          If FileExists(ChangeFileExt(TempFName,'.$$$')) Then Begin
            DeleteFile(TempFName);
            RenameFile(ChangeFileExt(TempFName,'.$$$'),TempFName)
          End;
        End;
      Except
        Fatal(Format(msgIdxTableNotFound,[ExtractFileName(TempFName)]));
      End;
    End;
  End;
End;

{----------------------------------------------------------------------------}
procedure TDBF.MakeIndex(Const IdxName:String; Const Key:TKey);
{vytvori index                                                               }
{----------------------------------------------------------------------------}
Var
  F:File;
  I,L:LongInt;
  A,B,FLD:Integer;
  S:String;
  T:TStringList;
Begin
  {Musi existovat a byt otevrena neprazdna tabulka, lze pouzit i pro preindexovani}
  If Not (FDBFExist And  FDBFIsOpened And (FDBFHeader.NumRecs>0)) Then Exit;
  {Otevri ji na stejnem miste, pouzij idxname = cele jmeno souboru}
  AsSignFile(F,IdxName);
  Try
    Rewrite(F,1);
    Try
      B := 0;A := -1;
      {do teto velikosti to lze setridit pres stringlist jinak per partes}
      If FDBFHeader.NumRecs<MaxItems Then Begin
        T:=TStringList.Create;
        Try
          {budes tridit radky}
          T.Sorted:=True;
          For FLD:=1 To FDBFCountItems Do
            If Trim(FDBFFields[FLD].Name)=Key Then Break;
          {nastavujes vlastnost duplicit}
          Case FDBFFields[FLD].idxtyp Of
            dbfUnique:T.Duplicates := dupError;
            dbfDuplicates:T.Duplicates := dupAccept;
          End;
          {projdes celou tabulku a vytahnes z ni pozadovane pole}
          For I := 0 To FDBFHeader.NumRecs-1 Do Begin
            Seek(I);
            ELoad(Key,S);
            {vlozis ho i s pozici do seznamu}
            Try
              T.Add(' '+S+#1+IntToStr(I));
            Except
              On EListError Do
                If T.Duplicates = dupError Then Fatal(msgDuplicateInUnique);
            End;
            {aktualizujes citac - vhodne je tez nastavovat kurzor}
            B:=Round((I+1)/(FDBFHeader.NumRecs/100));
            If A<>B Then Begin {tohle je proto, aby se progress volal jen 101x}
              A := B;
              If AsSigned(FOnProgress) Then FOnProgress(Self,prgMakeIndexSort,B);
            End;
          End;
          {znovu projdes seznam, upravis ho do tvaru <cislo><klic> a zapises}
          If AsSigned(FOnProgress) Then FOnProgress(Self,prgWriteIndexSort,B);
          Case FDBFFields[FLD].idxsrt Of
            dbfDescending:
              For I:=T.Count-1 DownTo 0 Do Begin
                S:=T.Strings[I];
                L:=StrToInt(Copy(S,Pos(#1,S)+1,255));
                S:='   '+Copy(S,1,Pos(#1,S)-1);
                Move(L,S[1],SizeOf(L));
                BlockWrite(F,S[1],Length(S));
              End;
            dbfAscending:
              For I:=0 To T.Count-1 Do Begin
                S:=T.Strings[I];
                L:=StrToInt(Copy(S,Pos(#1,S)+1,255));
                {dopredu tri mezery, jedna tam uz je}
                S:='   '+Copy(S,1,Pos(#1,S)-1);
                Move(L,S[1],SizeOf(L));
                BlockWrite(F,S[1],Length(S));
              End;
            dbfAlternative:
            Begin
              {Potrebujete-li to, tak jedine doprogramovat}
              If AsSigned(FDBFOnAltSort) Then FDBFOnAltSort(Self,T);
              For I:=0 To T.Count-1 Do Begin
                S:=T.Strings[I];
                L:=StrToInt(Copy(S,Pos(#1,S)+1,255));
                S:='   '+Copy(S,1,Pos(#1,S)-1);
                Move(L,S[1],SizeOf(L));
                BlockWrite(F,S[1],Length(S));
              End;
            End;
          End;
        Finally
          T.Free
        End;
      End
      Else
        Warn(msgFileIsTooLarge);
    Finally
      CloseFile(F)
    End;
  Except
    Fatal(msgNotEnoughtCreateIdx)
  End;
End;

{----------------------------------------------------------------------------}
Function TDBF.ReIndex;
{provede reindexovani tabulky}
{----------------------------------------------------------------------------}
Var
  I:Integer;
  TempFName:String;
Begin
  Result := False;
  {je-li tabulka zrovna otevrena, tak nedelej nic}
  If IsMarked Then Exit;
  {nemuzes-li si ji otevrit taky pro sebe, tak taky nic nedelej}
  If Not Cover Then Exit;
  Try
    For I:=1 To FDBFCountItems Do Begin
      {prochazis vsechny sloupce a hledas indexovy soubor}
      If Trim(FDBFFields[I].Idx)<>'' Then Begin
        {indexovy soubor byl nalezen}
        {jeho jmeno je ve tvaru xxxxxxxxIDX, vzdy zarovnan jako soubor 8-3}
        {vyplne jsou ' ' tj. "~~~JMENOIDX" nebo "~~ZAMESTID~"}
        {vyrob temp jmeno souboru}
        TempFName:=ExtractFilePath(FDBFName)
         +Trim(Copy(FDBFFields[I].Idx,1,8)+'.'+Copy(FDBFFields[I].Idx,9,3));

        MakeIndex(TempFName,Trim(FDBFFields[I].Name))
      End;
    End;
  Finally
    UnCover;
    Result := True;
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.Update(R:LongInt);
{----------------------------------------------------------------------------}
Begin
  {bude-li zaznam aktualizovan tesne pred update, dej to vedet i s flagem}
  If AsSigned(FOnActualize) Then FOnActualize(Self,dbfUpdate);
  {zapis zaznam z bufferu}
  Write(CurrRec);
  {udelej jeste obnoveni/refresh, ale asi neni uz nutne}
  Seek(CurrRec);
End;

{----------------------------------------------------------------------------}
Procedure TDBF.Store(Const Key:TKey; Const Rec:String);
{vlozi hodnotu do bufferu aktualniho zaznamu dle klice pole                  }
{----------------------------------------------------------------------------}
Var
  I,Posic:Integer;
  S:String;
Begin
  {pozice zacina od jedne, i kdyz je buffer od 0 protoze na }
  {pozici 0 je indikacni byte o vymazani vety}
  Posic := 1;
  For I := 1 To FDBFCountItems Do Begin
    If Trim(FDBFFields[I].Name) = UpperCase(Key) Then Break
    Else Inc(Posic,FDBFFields[I].Len);
  End;
  S:=Rec;
  If Length(S)<FDBFFields[I].Len Then
    Case FDBFFields[I].What of
      'C','L':While Length(S)<FDBFFields[I].Len Do S := S + ' ';
      'F','N','M':While Length(S)<FDBFFields[I].Len Do S := ' ' + S;
      'D':;{date je vzdy na 8 znaku ddmmyyy nebo mmddyyyy}
      'T':;{time je vzdy na 6 znaku hhmmss}
    End;
  Move(S[1],FDBFBuff^[Posic],FDBFFields[I].Len);
End;

{----------------------------------------------------------------------------}
Procedure TDBF.ELoad(Const Key:TKey; Var Rec:String);
{Precte hodnotu z bufferu aktualniho zaznamu dle klice pole                  }
{----------------------------------------------------------------------------}
Var
  I,Posic:Integer;
Begin
  {pozice zacina od jedne, i kdyz je buffer od 0 protoze na }
  {pozici 0 je indikacni byte o vymazani vety}
  Posic := 1;
  {nejprve musi najit jmeno pole a nascitat pocatek}
  For I := 1 To FDBFCountItems Do Begin
    If Trim(FDBFFields[I].Name) = UpperCase(Key) Then Break
    Else Inc(Posic,FDBFFields[I].Len);
  End;
  {predej zaznam neotrimovany}
  Move(FDBFBuff^[Posic],Rec[1],FDBFFields[I].Len);
  Rec[0]:=Chr(FDBFFields[I].Len);
End;

{----------------------------------------------------------------------------}
Function TDBF.Load(Const Key:TKey):String;
{tohle je uzivatelska modifikace funkce ELoad, ktera orizne mezery}
{----------------------------------------------------------------------------}
Begin
  {vola standarni funkci}
  ELoad(Key,Result);
  {a tady jeste orizne nadbytecne mezery}
  Result:=Trim(Result);
End;

{----------------------------------------------------------------------------}
Procedure TDBF.Find(Const IdxName, Value{toto je vlastne klic}:String);
{hleda hodnotu podle klice idxname je jmeno sloupce value je hodnota
 funkcionalitu = <> > < >= <= dodava onquery}
{----------------------------------------------------------------------------}
  Function SizeOfKey(Const Key:String):Integer;
  {vraci sirku klice/pole}
  Var I:Integer;
  Begin
    For I := 1 To FDBFCountItems Do Begin
      If Trim(FDBFFields[I].Name) = UpperCase(Key) Then Begin
        Result := FDBFFields[I].Len;
        Exit
      End;
    End;
    Result:=0;
    Warn(Format(msgIdxFieldNotFound,[Key]));
  End;
Var
  F:File;
  A,B,Size:Integer;
  S:String;
  I,N,L:LongInt;
  OK, Cancel:Boolean;
Begin
  {Musi existovat a byt otevrena neprazdna tabulka, lze pouzit i pro preindexovani}
  If Not (FDBFExist And  FDBFIsOpened And (FDBFHeader.NumRecs>0)) Then Exit;
  {tato procedura musi byt attachnuta, aby mohl dotaz fungovat}
  If Not AsSigned(FOnQuery) Then Exit;
  {tahle taky, aby se dala predavat data}
  If Not AsSigned(FOnFound) Then Exit;
  {Otevri ji na stejnem miste, pouzij idxname a defaultni priponu}
  AsSignFile(F,ExtractFilePath(FDBFName)+IdxName);
  Try
    ReSet(F,1);
    Try
      B :=SizeOfKey(Value);
      {v tomto pripade vydano varovani a odchod, klic musi byt nenulovy}
      If B=0 Then Exit;
      {sestaveni zaznamu}
      Size:=B+SizeOf(LongInt);
      {overeni na velikost souboru}
      I := FileSize(F);
      {v pripade ze neco zbyde (polozky nejsou align) tak chyba}
      If (I Mod Size) <> 0 Then Begin
        Fatal(Format(msgErrorOnIdxTable,[IdxName]));
        Exit;
      End;
      {tohle je pocet polozek}
      N := I Div Size;
      {nastav prostor na S}
      S:='';For I := 1 To Size Do S:=S+' ';
      Cancel:=False;
      {prochazej periodicky klic}
      B := 0; A := -1;
      For I := 0 To N-1 Do Begin
        BlockRead(F,S[1],Size);
        S[0]:=Chr(Size);
        Move(S[1],L,SizeOf(L));
        S:=Copy(S,5,255);
        {zde je dotaz na tabulku, uzivatel filtruje dle pole}
        OK:=False;{predpoklad, ze ho nechci}
        FOnQuery(Self,IdxName,Value,Trim(S),OK, Cancel);
        If OK Then Begin
          {je-li pozadovany filtr akceptovan, vyzvedni zaznam}
          Seek(L);
          {zaznam se musi zpracovat, jinak jsou data ztracena}
          {zde se data ctou napr. do listboxu nebo stringgridu}
          FOnFound(Self);
        End;
        {aktualizujes citac - vhodne je tez nastavovat kurzor}
        B:=Round((I+1)/(N/100));
        If Cancel Then B:=100;
        If A<>B Then Begin {tohle je proto, aby se progress volal jen 101x}
          A := B;
          If AsSigned(FOnProgress) Then FOnProgress(Self,prgSearchByKey,B);
        End;
        If Cancel Then Break;
      End;
    Finally
      CloseFile(F)
    End;
  Except
    Fatal(Format(msgIdxTableNotFound,[ExtractFilePath(FDBFName)+IdxName]));
  End;
End;

{----------------------------------------------------------------------------}
Function TDBF.Cover:Boolean;
{nastavuje bit transakce}
{----------------------------------------------------------------------------}
Var
  F: File;
  B: Byte;
Begin
  Result := False;
  If IsMarked Then Exit;
  AssignFile(F, FDBFName);
  Try
    Reset(F, 1);
    Try
      B:=1;
      System.Seek(F, 14);
      BlockWrite(F, B, 1);
      Result := True;
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Warn(msgFileTooRemote);
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.UnCover;
{shazuje bit transakce}
{----------------------------------------------------------------------------}
Var
  F: File;
  B: Byte;
Begin
  If Not IsMarked Then Exit;
  AssignFile(F, FDBFName);
  Try
    Reset(F, 1);
    Try
      B:=0;
      System.Seek(F, 14);
      BlockWrite(F, B, 1);
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Warn(msgFileTooRemote);
  End;
End;

{----------------------------------------------------------------------------}
procedure TDBF.RemoveIndex(Const Name: String);
{explicitni zruseni indexu .mdx a zruseni propojeni}
{----------------------------------------------------------------------------}
Var
  F: File;
  B: Byte;
Begin
  AssignFile(F, FDBFName);
  Try
    Reset(F, 1);
    Try
      System.Seek(F, 28);
      B := 0;
      BlockWrite(F, B, 1);
      DeleteFile(ChangeFileExt(Name, '.mdx'));
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Warn(msgCannotOpenTable)
  End;
End;

{----------------------------------------------------------------------------}
Function TDBF.IsMarked:Boolean;
{vraci priznak, zda je nastavena transakce}
{----------------------------------------------------------------------------}
Var
  F: File;
  B: Byte;
Begin
  Result := True;
  AssignFile(F, FDBFName);
  Try
    Reset(F, 1);
    Try
      System.Seek(F, 14);
      BlockRead(F, B, 1);
      Result := B = 1;
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Warn(msgFileTooRemote);
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.IncNumRec;
{procedura zvysi pocet zaznamu o jeden}
{----------------------------------------------------------------------------}
Var
  F: File;
  L: LongInt;
Begin
  AssignFile(F, FDBFName);
  Try
    Reset(F, 1);
    Try
      System.Seek(F, 4);
      BlockRead(F, L, SizeOf(L));
      Inc(L);
      FDBFHeader.numRecs:=L;
      System.Seek(F, 4);
      BlockWrite(F, L, SizeOf(L));
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Warn(msgFileTooRemote);
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.Actualization;
{zapis do hlavicky aktualni datum}
{----------------------------------------------------------------------------}
Var
  F: File;
  S: String[3];
  Year, Month, Day: Word;
Begin
  AssignFile(F, FDBFName);
  Try
    Reset(F, 1);
    Try
      System.Seek(F, 1);
      BlockRead(F, S[1], 3);
      DecodeDate(Date, Year, Month, Day);
      Byte(S[1]):=(Year Mod 100);
      Byte(S[2]):=Month;
      Byte(S[3]):=Day;
      Move(S[1],FDBFHeader.Year,3);
      System.Seek(F, 1);
      BlockWrite(F, S[1], 3);
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Warn(msgFileTooRemote);
  End;
End;

{----------------------------------------------------------------------------}
Function TDBF.SaveMemo(No:LongInt;Const FName:String):Boolean;
{ulozi soubor do memo}
{----------------------------------------------------------------------------}
Var F,FF:File;
    T:TDBTTypes;
    S:String[79];
    SR:TSearchRec;
    A:Array[1..1024] of Char;
    NumRead, NumWritten:{$IfDef VER80}Word{$Else}Integer{$EndIf};
Begin
  Result:=False;
  If Not FileExists(FName) Then Exit;
  If FindFirst(FName,faAnyFile,SR)<>0 Then Exit;
  FindClose(SR);
  AsSignFile(F,ChangeFileExt(FDBFName,'.DBT'));
  Try
    {$I-}
    ReSet(F,1);
    {$I+}
    If IoResult<>0 Then ReWrite(F,1);
    {zapis vety}
    Try
      System.Seek(F,System.FileSize(F));
      With T Do Begin
        NumberOf:=No;    { cislo zaznamu}
        S:=ExtractFileExt(FName);
        If Length(S)<=3 Then
          Move(S[1],AsFileType,Length(S)); { extense ulozeneho typu}
        Used:=True;                     { pouzito}
        SizeOfMemo:=SR.Size; { velikost pripojeneho souboru}
        FileDateTime:=FileDateToDateTime(SR.Time); { originalni datum a cas souboru}
      End;
      BlockWrite(F,T,SizeOf(T));
      {prekopiruj soubor do memo}
      AsSignFile(FF,FName);
      ReSet(FF,1);
      Try
        Repeat
          BlockRead(FF, A, SizeOf(A), NumRead);
          BlockWrite(F, A, NumRead, NumWritten);
        Until (NumRead = 0) or (NumWritten <> NumRead);
      Finally
        CloseFile(FF)
      End;
      Result:=True;
    Finally
      CloseFile(F);
    End;
  Except
    On EInOutError Do Fatal(msgErrorOnMemoOpen);
  End;
End;

{----------------------------------------------------------------------------}
Function TDBF.LoadMemo(No:LongInt;Var FName:String):Boolean;
{preda soubor z memo na disk do FName - zmeni u nej pouze extenzi dle uloz. typu}
{----------------------------------------------------------------------------}
Var F,FF:File;
    T:TDBTTypes;
    Readed:{$IfDef VER80}Word{$Else}Integer{$EndIf};
    C:Char;
    I:LongInt;
    Handle:Integer;
Begin
  Result:=False;
  AsSignFile(F,ChangeFileExt(FDBFName,'.DBT'));
  Try
    ReSet(F,1);
    Try
      T.NumberOf:=-1;
      {hleda hlavickovy zaznam}
      While T.NumberOf<>No Do Begin
        BlockRead(F,T,SizeOf(T),Readed);
        If Readed=0 Then Exit;
        System.Seek(F,System.FilePos(F)+T.SizeOfMemo);
      End;
      {nasels, vrat se}
      System.Seek(F,System.FilePos(F)-T.SizeOfMemo);
      {zapis ho na disk - je-li jineho typu, zmen extenzi!! }
      FName:=ChangeFileExt(FName,'.'+T.AsFileType);
      AsSignFile(FF,FName);
      Try
        ReWrite(FF,1);
        Try
          {prekopiruj to do souboru}
          For I:=1 To T.SizeOfMemo Do Begin
            BlockRead(F,C,SizeOf(C));
            BlockWrite(FF,C,SizeOf(C));
          End;
        Finally
          CloseFile(FF);
          {nastav puvodni datum souboru}
          Handle:=FileOpen(FName,fmOpenReadWrite);
          FileSetDate(Handle,DateTimeToFileDate(T.FileDateTime));
          FileClose(Handle);
        End;
      Except
        On EInOutError Do ;
      End;
      {a zapis}
      BlockWrite(F,T,SizeOf(T));
    Finally
      CloseFile(F);
    End;
    Result:=True;
  Except
    On EInOutError Do Fatal(msgErrorOnMemoOpen);
  End;

End;

{----------------------------------------------------------------------------}
Function TDBF.EraseMemo(No:LongInt):Boolean;
{oznaci soubor v memo za nepouzivany}
{----------------------------------------------------------------------------}
Var F:File;
    T:TDBTTypes;
    Readed:{$IfDef VER80}Word{$Else}Integer{$EndIf};
Begin
  Result:=False;
  AsSignFile(F,ChangeFileExt(FDBFName,'.DBT'));
  Try
    ReSet(F,1);
    Try
      T.NumberOf:=-1;
      While T.NumberOf<>No Do Begin
        BlockRead(F,T,SizeOf(T),Readed);
        If Readed=0 Then Exit;
        System.Seek(F,System.FilePos(F)+T.SizeOfMemo);
      End;
      {nasels, vrat se}
      System.Seek(F,System.FilePos(F)-T.SizeOfMemo-SizeOf(T));
      {Nastav priznak}
      T.Used:=False;
      {a zapis}
      BlockWrite(F,T,SizeOf(T));
    Finally
      CloseFile(F);
    End;
    Result:=True;
  Except
    On EInOutError Do Fatal(msgErrorOnMemoOpen);
  End;
End;

{----------------------------------------------------------------------------}
Procedure TDBF.PruneDBF;
{odstrani z tabulky vymazane zaznamy}
{----------------------------------------------------------------------------}
Begin
End;
{----------------------------------------------------------------------------}
Procedure TDBF.PruneDBT;
{odstrani z memo nepouzite zaznamy}
{----------------------------------------------------------------------------}
Begin
End;

End.
